extends Spatial

class_name GameServerRequests

var http:HTTPRequest


func _ready():
	http = HTTPRequest.new()
	add_child(http)
	http.connect("request_completed",self, "_self_destroy")


func connect_http(node,function):
	http.connect("request_completed",node,function)


func get_request(path:String):
	http.request(game_server.API_ADDR + path, game_server.HEADERS, game_server.SSL, HTTPClient.METHOD_GET)


func post_request(path:String, data:String = ""):
	http.request(game_server.API_ADDR + path, game_server.HEADERS, game_server.SSL, HTTPClient.METHOD_POST, data)


func put_request(path:String, data:String = ""):
	http.request(game_server.API_ADDR + path, game_server.HEADERS, game_server.SSL, HTTPClient.METHOD_PUT, data)


func delete_request(path:String, data:String = ""):
	http.request(game_server.API_ADDR + path, game_server.HEADERS, game_server.SSL, HTTPClient.METHOD_DELETE, data)


func _self_destroy(result, response_code, headers, body):
	queue_free()